unit rpt1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  QuickRpt, Db, DBTables, ExtCtrls, Qrctrls;

type
  TfrmRpt1 = class(TForm)
    QuickRep1: TQuickRep;
    Table1: TTable;
    DetailBand1: TQRBand;
    SummaryBand1: TQRBand;
    QRDBText1: TQRDBText;
    QRExpr1: TQRExpr;
    QRExpr2: TQRExpr;
    QRDBText2: TQRDBText;
    QRDBText3: TQRDBText;
    QRShape1: TQRShape;
    QRShape2: TQRShape;
    procedure DetailBand1AfterPrint(Sender: TQRCustomBand;
      BandPrinted: Boolean);
    procedure SummaryBand1BeforePrint(Sender: TQRCustomBand;
      var PrintBand: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
    LastDetailY: integer;
  end;

var
  frmRpt1: TfrmRpt1;

implementation

{$R *.DFM}

procedure TfrmRpt1.DetailBand1AfterPrint(Sender: TQRCustomBand;
  BandPrinted: Boolean);
begin
  // Save the current vertical drawing position.
  LastDetailY := Sender.ParentReport.CurrentY;
end;

procedure TfrmRpt1.SummaryBand1BeforePrint(Sender: TQRCustomBand;
  var PrintBand: Boolean);
var
  OfsX, OfsY: integer;
begin
  // Draw a connecting line from the bottom of the QRShape on the detail line
  // to the top of the QRShape on the summary band.


  // Get the current position on the page of the summary band
  OfsX := Sender.ParentReport.CurrentX;
  OfsY := Sender.ParentReport.CurrentY;

  if OfsY > LastDetailY then
    with Sender.ParentReport.QRPrinter do begin
      with Canvas do begin
        // Copy the brush & pen properties of the QRShape
        Brush := QRShape2.Brush;
        Pen := QRShape2.Pen;

        // Move the canvas's current drawing position to the vertical position
        // that we saved in the detail band's AfterPrint event
        MoveTo(XPos(OfsX+QRShape2.Size.Left + QRShape2.Size.Width / 2), YPos(LastDetailY));
        // Draw a line down to the top of the summary band
        LineTo(XPos(OfsX+QRShape2.Size.Left + QRShape2.Size.Width / 2), Ypos(OfsY));
      end;
    end;

end;

end.
